# Contributing

## Context

The bus package follows effective Go guidelines and `gofmt` tool to format
codes. It is expected from all contributors to follow the same rules in the
contributing guidelines.

### Readibility over efficiency

For the package, readibility is more important than efficiency of the software.
Ofcourse it doesn't mean that the contributors should write inefficient code.
It is usually possible to do the both at the same time. Unless it is a bug, the
maintainers should take the time to elaborate on different solutions and apply
the reasonable solution.

### Maximum chars in a line

It is intented to use at most `80 chars` in a line even if the Go programming
guidelines allows any number of character in a line. If you are planning to
contribute to the package, please be ready to accept this rule.

## Issues, Bugs, Documentation, Enhancements

Create an issue if there is a bug.

Fork the project.

Make your improvements and write your tests (make sure you covered all the
cases).

Make a pull request.
